﻿// Create an empty dialog window near the upper left of the screen
function SuperluminalGroupsWindow(windowResourceFolder, entries, selectedIndexes, multiSelection) {
	this.windowResourceFolder = windowResourceFolder;
	this.entries = entries;
	this.selectedIndexes = selectedIndexes;
	this.multiSelection = multiSelection;
	this.width = 500;
	this.height = 400;
	this.selectedEntry = 0;
	this.result = null;
	this.numEntries = 0;
	this.container;
	this.presetEntries = [];
	this.entryWidth = 200;
	this.entryHeight = 160;
	this.xGap = 2;
	this.yGap = 2;
	this.paramEntryHeight = 25;
	this.paramEntryMargins = 1;
	this.paramEntryGap = 1;
	this.groupMargins = 5;
	this.groupGap = 5;
	this.displayedGroups = [];
	this.dynEntries = [];
	
	this.SetupMainWindow = function() {
		this.window = new Window('dialog', 'Select Items');
		
		//this.window.properties.
		this.window.frameLocation = [100,100];
		this.window.size = [this.width,this.height];
		this.window.orientation = 'column';
		this.window.alignChildren = ['fill','top'];
		
		var g = this.window.graphics;
		g.backgroundColor = g.newBrush(g.BrushType.SOLID_COLOR, [0.15, 0.15, 0.15, 1]);
		//this.window.backgroundColor = [1,1,1,1];
		//this.window.preferredSize = [400, 0];
	
		var addControlHeight = 0;
	
		//create main content group.
		this.container = this.CreateScrollableGroup(this.window, [this.width - 10, this.height - (50 + addControlHeight)]);
		this.container.group.location = [5, 5 + addControlHeight];
		
		
		//add "apply" and "cancel" buttons.
		var apply = this.window.add('button', undefined, "Apply");

		var offset_y = 10;
		var offset_x = 5;

		apply.windowObj = this;
		apply.bounds = [this.width - 100 - offset_x, this.height - 30- offset_y, this.width -offset_x, this.height - offset_y];
		apply.onClick = function() { 
			this.windowObj.result = this.windowObj.CreateResultString();
			this.windowObj.window.close();
		}
        var prev = apply;
      
		var cancel = this.window.add('button', undefined, "Cancel");
		cancel.windowObj = this;
         cancel.bounds = prev.bounds;
         cancel.bounds.left -= 105;
         cancel.bounds.right -= 105;
         cancel.onClick = function() {
            this.windowObj.result = "null";
			this.windowObj.window.close();
		}
	}

	this.CreateResultString = function() {
		var resultStr = "[";
		var numHits = 0;
		for(var i = 0; i < this.dynEntries.length; i++) {
			if(this.dynEntries[i].groupData.selected) {
				if(numHits) resultStr  += ",";
				numHits++;
				resultStr += i;
			}
		}
		resultStr += "]";
		return resultStr;
	}

	this.LaunchWindow = function() {
		//this.window.layout.layout(true);
		//this.window.layout.resize();
		//this.window.onResizing = this.window.onResize = function () {this.layout.resize();}
		//this.window.resizeable = true;
		

		
		this.window.center();
		//this.window.size = [500,400];//disable this for snug fit.
		this.window.show();
	}

	this.CreateDropDown = function(container, title, entries, defaultIndex, triggerFunction) {
		var drop = container.add("dropdownlist", undefined);
		drop.title = title;
		drop.minimumSize = [10, 40];
		for(var i = 0; i < entries.length; i++) {
			if("separator" in entries[i]) {
				drop.add('separator');
				continue;
			}
			var item = drop.add('item', entries[i].name);
			item.associatedObject = entries[i].associatedObject;
		}
		drop.selection = drop.items[defaultIndex];
		drop.onChange = triggerFunction;
		return drop;
	};

	this.CreateScrollableGroup = function(container, size) {
		var barWidth = 20;
		
		var p1= container.add('panel',undefined);
		p1.orientation = "row";
		p1.bounds = [0,0,size[0],size[1]];
		
		var p2= p1.add('group',undefined);
		p2.orientation = "stack";
		p2.bounds = [0,0,size[0] - barWidth,size[1] ];

		var s = p1.add('scrollbar',undefined); 
		s.bounds = [p1.bounds.width - barWidth, 0, p1.bounds.width, p1.bounds.height ];
		//s.size = [20, p1];
		
		//for (var n = 0; n < 20; n++) p2.add('edittext',[0,n*30,280,20+n*30], "Hi Roy #"+n);  
		
		s.onChanging = function () {
			var delta = p1.size[1] - p2.size[1];
			p2.location.y = delta * (s.value / 100) ;
			//p2.location.y = s.value*(p1.bounds[3]-p1.bounds[1])/100 - s.value*(p2.bounds[3]-p2.bounds[1])/100;
			//p2.location.y = 100;
		}; 
	
		var ScrollGroup = {group: p1, innerContainer: p2, scrollbar: s, contentHeight: 0};
		
		return ScrollGroup;
	};

	this.CreateEntryContent = function(container, entryData) {
		var entry = { entryData: entryData, windowClass: this };
		
		entry.group = container.add("group", undefined);
		entry.group.bounds = [this.paramEntryMargins, this.paramEntryMargins, container.bounds.width - 10 - 2, 25];
		var g = entry.group.graphics;
		g.backgroundColor = g.newBrush(g.BrushType.SOLID_COLOR, [1, 1, 1, 1]);
		
		entry.text = entry.group.add("statictext", undefined, entryData.name);
		var name_marg = 20;
		entry.text.size = [300 - name_marg, 25];
		entry.text.location = [this.paramEntryMargins + name_marg, 0];
		
		entry.stateButton = entry.group.add("radiobutton", undefined, "");
		entry.stateButton.value = false;
		entry.stateButton.size = [50, entry.group.bounds.height - 4];
		entry.stateButton.location = [this.paramEntryMargins +  2+ 0*(entry.group.bounds.width - (50 + this.paramEntryMargins)),  5];
		entry.stateButton.parentEntry  = entry;

		entry.stateButton.onClick = function() {
			//alert("clicked");
			this.parentEntry.handleStateSwitch();
		}
	
		entry.applyState = function() {
			if(this.entryData.selected) {
				this.stateButton.value = true;
				this.stateButton.text = "";
				var g = entry.group.graphics;
				g.backgroundColor = g.newBrush(g.BrushType.SOLID_COLOR, [0.10, 0.10, 0.10, 1]);
			} else {
				this.stateButton.value = false;
				this.stateButton.text = "";
				var g = entry.group.graphics;
				g.backgroundColor = g.newBrush(g.BrushType.SOLID_COLOR, [0.13, 0.13, 0.13, 1]);
			}
		};
	
		entry.handleStateSwitch = function() {
			//if we're in multiselection mode, we allow toggeling otherwise all clicks are "on".
			if(this.windowClass.multiSelection) {
				this.entryData.selected = !this.entryData.selected;
			} else {
				this.windowClass.DeselectAllEntries();
				this.entryData.selected = true;
			}
			this.applyState();
		}
	
		entry.applyState();
		
		return entry;
	};

	this.DeselectAllEntries = function() {
		for(var i = 0; i < this.dynEntries.length; i++) {
			this.dynEntries[i].groupData.selected = false;
			this.dynEntries[i].content.applyState();
		}
	}

	this.CreateEntry = function(groupData) {
		var entry = {
			groupData: groupData,
		};
	
		this.dynEntries.push(entry);
		
		var groupContainer = this.container.innerContainer.add("panel", undefined);
		groupContainer.bounds = [5, 5, this.container.innerContainer.bounds.width - 10, 200];
		groupContainer.orientation = 'stack';
//			entryContainer.bounds = [x, y, x + this.entryWidth, y + this.entryHeight];
//			entryContainer.entryIndex = i;
		entry.group = groupContainer;

		var g = groupContainer.graphics;
		g.backgroundColor = g.newBrush(g.BrushType.SOLID_COLOR, [0.15, 0.15, 0.15, 1]);
			
		//add sub entries
		var lastY = this.paramEntryGap * 2;
		
		var content = this.CreateEntryContent(groupContainer, groupData);
		entry.content = content;
		content.group.location = [5, lastY];
		lastY += this.paramEntryHeight + this.paramEntryGap;
	
		groupContainer.bounds.height = lastY + this.paramEntryMargins - this.paramEntryGap;

		this.AddGroup(entry);
		return entry;
	};

	this.GetEntrySelectionState = function(entry) {
		for(var i = 0; i < this.selectedIndexes.length; i++) {
			if(this.selectedIndexes[i] == entry.ind) return true;
		}
		return false;
	}

	this.SetEntrySelectionState = function(entry, state) {
		for(var i = 0; i < this.selectedIndexes; i++) {
			if(this.selectedIndexes[i] == entry.ind) {
				if(state) return;
				this.selectedIndexes.splice(i, 1);
				return;
			}
		}
		this.selectedIndexes.push(entry.ind);
	}

	this.ArrangeGroups = function() {
		var lastY = this.groupMargins;
		var groups = this.displayedGroups;
		for(var i = 0; i < groups.length; i++) {
			groups[i].group.location = [this.groupMargins, lastY];
			lastY += groups[i].group.bounds.height + this.groupGap;
		}
		this.container.innerContainer.bounds.height = lastY;
	};

	this.AddGroup = function(group) {
		group.groupData.enabled = true;
		this.displayedGroups.push(group);
		this.ArrangeGroups();
	};

	this.RemoveGroup = function(group) {
		group.groupData.enabled = false;
		var groups = this.displayedGroups;
		for(var i = 0; i < groups.length; i++) {
			if(groups[i] == group) {
				groups.splice(i, 1);
				group.group.parent.remove(group.group);
				break;
			}
		}
		this.ArrangeGroups();
	};

	this.SetupCurrentState = function() {
		for(var i = 0; i < this.entries.length; i++) {
			var entry = {name: this.entries[i], ind: i };
			entry.selected = this.GetEntrySelectionState(entry);
			this.CreateEntry(entry);
		}
		this.ArrangeGroups();
	}

	this.Pipeline = function() {
		this.SetupMainWindow();
		this.SetupCurrentState();
		this.LaunchWindow();
	}

	//pipeline
	this.Pipeline();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//PIPELINE
function SuperluminalLaunchItemSelectionWindow(windowResourceFolder, entries, selectedIndexes, multiSelection) {
	var windowObj = new SuperluminalGroupsWindow(windowResourceFolder, entries, selectedIndexes, multiSelection);
	return windowObj.result;
}

//SuperluminalLaunchItemSelectionWindow(null, ["yo", "mamma", "how", "you", "doin"], [2, 3], false);
