﻿// Create an empty dialog window near the upper left of the screen
function SuperluminalTexturesWindow(windowResourceFolder) {
	this.windowResourceFolder = windowResourceFolder;
	this.data = null;
	this.width = 500;
	this.height = 400;
	this.selectedEntry = 0;
	this.result = null;
	this.numEntries = 0;
	this.container;
	this.entryWidth = 200;
	this.entryHeight = 35;
	this.xGap = 2;
	this.yGap = 2;
	this.paramEntryHeight = 25;
	this.paramEntryMargins = 1;
	this.paramEntryGap = 1;
	this.groupMargins = 5;
	this.groupGap = 5;
	this.displayedGroups = [];
	this.windowIsShown = false;
	this.valueHasChanged = false;
	
	this.SetupContentGroupUI = function() {
		if(this.container) this.window.remove(this.container.group);
		this.container = this.CreateScrollableGroup(this.window, [this.width - 10, this.height - 50]);
		this.container.group.location = [5, 5 + this.addControlHeight];
	}
	
	this.SetupMainWindow = function() {
		this.window = new Window('palette', 'Model Node - Texture Selector');
		
		this.window.onClose = function() {
			superluminalTexturesAssociationWindow.windowIsShown = false;
			superluminalTexturesAssociationWindow.window = null;
			superluminalTexturesAssociationWindow.container = null;
			superluminalTexturesAssociationWindow.SetupMainWindow();
		}
		
		//this.window.properties.
		this.window.frameLocation = [100,100];
		this.window.size = [this.width,this.height];
		this.window.orientation = 'column';
		this.window.alignChildren = ['fill','top'];
		
		var g = this.window.graphics;
		g.backgroundColor = g.newBrush(g.BrushType.SOLID_COLOR, [0.15, 0.15, 0.15, 1]);
		//this.window.backgroundColor = [1,1,1,1];
		//this.window.preferredSize = [400, 0];
	
		this.addControlHeight = 0;
	
		//create main content group.
		//this.SetupContentGroupUI();
		
		//add "apply" and "cancel" buttons.
		var apply = this.window.add('button', undefined, "Done");

		var offset_y = 10;
		var offset_x = 5;

		apply.windowObj = this;
		apply.bounds = [this.width - 100 - offset_x, this.height - 30- offset_y, this.width -offset_x, this.height - offset_y];
		apply.onClick = function() { 
			this.windowObj.CloseWindow();
		}
        var prev = apply;
	}

	this.OpenWindow = function() {
		//this.window.layout.layout(true);
		//this.window.layout.resize();
		//this.window.onResizing = this.window.onResize = function () {this.layout.resize();}
		//this.window.resizeable = true;
		if(!this.window) this.SetupMainWindow();
		this.windowIsShown = true;
		this.window.center();
		//this.window.size = [500,400];//disable this for snug fit.
		this.window.show();
	};

	this.CloseWindow = function() {
		this.window.close();
	};	

	this.CreateDropDown = function(container, title, entries, defaultIndex, triggerFunction) {
		var drop = container.add("dropdownlist", undefined);
		drop.title = title;
		drop.minimumSize = [10, this.entryHeight];
		for(var i = 0; i < entries.length; i++) {
			if("separator" in entries[i]) {
				drop.add('separator');
				continue;
			}
			var item = drop.add('item', entries[i].name);
			item.associatedObject = entries[i].associatedObject;
		}
		if(defaultIndex >= 0) {
			drop.selection = drop.items[defaultIndex];
		} else {
			drop.selection = null;
		}
		drop.onChange = triggerFunction;
		return drop;
	};

	this.HandleValueChange = function() {
		if(!this) {
			//we're probably seeing a call to pop up that was clicked on, but destroyed before the selection was made.
			//it probably lingers around and triggers an invalid call for the value change when clicked on again.
			//alert("invalid element called");
			return;
		}
		//alert("changed value");
		superluminalTexturesAssociationWindow.valueHasChanged = true;
	};

	this.CreateScrollableGroup = function(container, size) {
		var barWidth = 20;
		
		var p1= container.add('panel',undefined);
		p1.orientation = "row";
		p1.bounds = [0,0,size[0],size[1]];
		
		var p2= p1.add('group',undefined);
		p2.orientation = "stack";
		p2.bounds = [0,0,size[0] - barWidth,size[1] ];

		var s = p1.add('scrollbar',undefined); 
		s.bounds = [p1.bounds.width - barWidth, 0, p1.bounds.width, p1.bounds.height ];
		//s.size = [20, p1];
		
		//for (var n = 0; n < 20; n++) p2.add('edittext',[0,n*30,280,20+n*30], "Hi Roy #"+n);  
		
		s.onChanging = function () {
			var delta = p1.size[1] - p2.size[1];
			p2.location.y = delta * (s.value / 100) ;
			//p2.location.y = s.value*(p1.bounds[3]-p1.bounds[1])/100 - s.value*(p2.bounds[3]-p2.bounds[1])/100;
			//p2.location.y = 100;
		}; 
	
		var ScrollGroup = {group: p1, innerContainer: p2, scrollbar: s, contentHeight: 0};
		
		return ScrollGroup;
	};

	this.CreateGroupEntry = function(container, entryData) {
		var entry = { entryData: entryData };
		
		entry.group = container.add("group", undefined);
		entry.group.bounds = [this.paramEntryMargins, this.paramEntryMargins, container.bounds.width - 10 - 2, this.entryHeight];
		var g = entry.group.graphics;
		g.backgroundColor = g.newBrush(g.BrushType.SOLID_COLOR, [1, 1, 1, 1]);
		
		entry.text = entry.group.add("statictext", undefined, "Mesh: " + entryData.name);
		var name_marg = 20;
		entry.text.size = [300 - name_marg, this.entryHeight];
		entry.text.location = [this.paramEntryMargins + name_marg, 0];
		
		entry.stateButton = entry.group.add("radiobutton", undefined, "");
		entry.stateButton.value = entryData.enabled;
		entry.stateButton.size = [50, this.entryHeight];
		entry.stateButton.location = [this.paramEntryMargins +  2,  10];
		entry.stateButton.parentEntry  = entry;
		entry.stateButton.masterObj  = this;
		
		entry.stateButton.onClick = function() {
			//alert("clicked");
			this.parentEntry.handleStateSwitch();
			this.masterObj.HandleValueChange();
		}
	
		var textureInd = this.LookupMaterialIndexByUID(entryData.materialUID);
		//texture not found.
		if(textureInd == -1) {
			//decide what to do with a missing texture.
			if(entryData.materialUID) {
				//what to do when a texture was assigned, but is not loger available.
			} else {
				//what to do when no texture was ever assigned.
			}
		}
		entry.handleTextureChange = function() {
			var ind = this.selection.index;
			this.parentEntry.entryData.materialUID = this.masterObj.materials[ind].uid;
			this.masterObj.HandleValueChange();
		};
		entry.textureSelector = this.CreateDropDown(entry.group, "Material:", this.materials, textureInd, entry.handleTextureChange);
		entry.textureSelector.size = [200, entry.group.bounds.height - 4];
		entry.textureSelector.location = [this.entryWidth - 50 ,  0];
		entry.textureSelector.parentEntry  = entry;
		entry.textureSelector.masterObj  = this;

		entry.applyState = function() {
			if(this.entryData.enabled) {
				this.stateButton.value = true;
				this.stateButton.text = "";
				var g = entry.group.graphics;
				g.backgroundColor = g.newBrush(g.BrushType.SOLID_COLOR, [0.10, 0.10, 0.10, 1]);
			} else {
				this.stateButton.value = false;
				this.stateButton.text = "";
				var g = entry.group.graphics;
				g.backgroundColor = g.newBrush(g.BrushType.SOLID_COLOR, [0.13, 0.13, 0.13, 1]);
			}
		};
	
		entry.handleStateSwitch = function() {
			this.entryData.enabled = !this.entryData.enabled;
			this.applyState();
		};
	
		entry.applyState();
		
		return entry;
	};

	this.ArrangeGroups = function() {
		var lastY = this.groupMargins;
		var groups = this.displayedGroups;
		for(var i = 0; i < groups.length; i++) {
			groups[i].group.location = [this.groupMargins, lastY];
			lastY += groups[i].group.bounds.height + this.groupGap;
		}
		this.container.innerContainer.bounds.height = lastY;
	};

	this.AddGroup = function(group) {
		group.groupData.enabled = true;
		this.displayedGroups.push(group);
		this.ArrangeGroups();
	};

	this.RemoveGroup = function(group) {
		group.groupData.enabled = false;
		var groups = this.displayedGroups;
		for(var i = 0; i < groups.length; i++) {
			if(groups[i] == group) {
				groups.splice(i, 1);
				group.group.parent.remove(group.group);
				break;
			}
		}
		this.ArrangeGroups();
	};

	this.LookupMaterialIndexByUID = function(uid) {
		var mat = this.materials;
		for(var i = 0; i < mat.length; i++) {
			if(mat[i].uid == uid) return i;
		}
		return -1;
	};

	this.SetData = function(data, retainScroll) {
		if(!this.window) this.SetupMainWindow();
		
		this.valueHasChanged = false;
		this.data = data;
		this.window.text = '"' + this.data.node.name + '" Model Node - Texture Selector';
		
		var scroll = 0;
		if(retainScroll) scroll = this.container.scrollbar.value;
		this.SetupContentGroupUI();
		this.displayedGroups = [];
		
		//listing materials.
		this.materials = [{name:"None", uid:'0'}];
		var mat = this.data.materials;
		for(var i = 0; i < mat.length; i++) {
			this.materials.push(mat[i]);
		}
		
		//create ui for meshes.
		this.meshes = [];
		var msh = this.data.meshes;
		for(var i = 0; i < msh.length; i++) {
			var entry = msh[i];
			//if(!entry.enabled) continue;
			var newGroup = this.CreateGroupEntry(this.container.innerContainer, entry);
			this.displayedGroups.push(newGroup);
		}
		this.ArrangeGroups();
		
		if(scroll) {
			this.container.scrollbar.value = scroll;
			this.container.scrollbar.onChanging();
		}
	};

	this.ChangeApplied = function() {
		this.valueHasChanged = false;
	};

	this.SetDataFromString = function(str, retainScroll) {
		var data = eval('(' + str + ')');
		this.SetData(data, retainScroll);
	};

	this.GetDataAsString = function() {
		return JSON.stringify(this.data);
	};
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//JSON
//https://github.com/douglascrockford/JSON-js/blob/master/json2.js
if (typeof JSON !== "object") {
    JSON = {};
}

(function () {
    "use strict";

    var rx_one = /^[\],:{}\s]*$/;
    var rx_two = /\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g;
    var rx_three = /"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g;
    var rx_four = /(?:^|:|,)(?:\s*\[)+/g;
    var rx_escapable = /[\\\"\u0000-\u001f\u007f-\u009f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g;
    var rx_dangerous = /[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g;

    function f(n) {
        // Format integers to have at least two digits.
        return n < 10
            ? "0" + n
            : n;
    }

    function this_value() {
        return this.valueOf();
    }

    if (typeof Date.prototype.toJSON !== "function") {

        Date.prototype.toJSON = function () {

            return isFinite(this.valueOf())
                ? this.getUTCFullYear() + "-" +
                        f(this.getUTCMonth() + 1) + "-" +
                        f(this.getUTCDate()) + "T" +
                        f(this.getUTCHours()) + ":" +
                        f(this.getUTCMinutes()) + ":" +
                        f(this.getUTCSeconds()) + "Z"
                : null;
        };

        Boolean.prototype.toJSON = this_value;
        Number.prototype.toJSON = this_value;
        String.prototype.toJSON = this_value;
    }

    var gap;
    var indent;
    var meta;
    var rep;


    function quote(string) {

// If the string contains no control characters, no quote characters, and no
// backslash characters, then we can safely slap some quotes around it.
// Otherwise we must also replace the offending characters with safe escape
// sequences.

        rx_escapable.lastIndex = 0;
        return rx_escapable.test(string)
            ? "\"" + string.replace(rx_escapable, function (a) {
                var c = meta[a];
                return typeof c === "string"
                    ? c
                    : "\\u" + ("0000" + a.charCodeAt(0).toString(16)).slice(-4);
            }) + "\""
            : "\"" + string + "\"";
    }


    function str(key, holder) {

// Produce a string from holder[key].

        var i;          // The loop counter.
        var k;          // The member key.
        var v;          // The member value.
        var length;
        var mind = gap;
        var partial;
        var value = holder[key];

// If the value has a toJSON method, call it to obtain a replacement value.

        if (value && typeof value === "object" &&
                typeof value.toJSON === "function") {
            value = value.toJSON(key);
        }

// If we were called with a replacer function, then call the replacer to
// obtain a replacement value.

        if (typeof rep === "function") {
            value = rep.call(holder, key, value);
        }

// What happens next depends on the value's type.

        switch (typeof value) {
        case "string":
            return quote(value);

        case "number":

// JSON numbers must be finite. Encode non-finite numbers as null.

            return isFinite(value)
                ? String(value)
                : "null";

        case "boolean":
        case "null":

// If the value is a boolean or null, convert it to a string. Note:
// typeof null does not produce "null". The case is included here in
// the remote chance that this gets fixed someday.

            return String(value);

// If the type is "object", we might be dealing with an object or an array or
// null.

        case "object":

// Due to a specification blunder in ECMAScript, typeof null is "object",
// so watch out for that case.

            if (!value) {
                return "null";
            }

// Make an array to hold the partial results of stringifying this object value.

            gap += indent;
            partial = [];

// Is the value an array?

            if (Object.prototype.toString.apply(value) === "[object Array]") {

// The value is an array. Stringify every element. Use null as a placeholder
// for non-JSON values.

                length = value.length;
                for (i = 0; i < length; i += 1) {
                    partial[i] = str(i, value) || "null";
                }

// Join all of the elements together, separated with commas, and wrap them in
// brackets.

                v = partial.length === 0
                    ? "[]"
                    : gap
                        ? "[\n" + gap + partial.join(",\n" + gap) + "\n" + mind + "]"
                        : "[" + partial.join(",") + "]";
                gap = mind;
                return v;
            }

// If the replacer is an array, use it to select the members to be stringified.

            if (rep && typeof rep === "object") {
                length = rep.length;
                for (i = 0; i < length; i += 1) {
                    if (typeof rep[i] === "string") {
                        k = rep[i];
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (
                                gap
                                    ? ": "
                                    : ":"
                            ) + v);
                        }
                    }
                }
            } else {

// Otherwise, iterate through all of the keys in the object.

                for (k in value) {
                    if (Object.prototype.hasOwnProperty.call(value, k)) {
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (
                                gap
                                    ? ": "
                                    : ":"
                            ) + v);
                        }
                    }
                }
            }

// Join all of the member texts together, separated with commas,
// and wrap them in braces.

            v = partial.length === 0
                ? "{}"
                : gap
                    ? "{\n" + gap + partial.join(",\n" + gap) + "\n" + mind + "}"
                    : "{" + partial.join(",") + "}";
            gap = mind;
            return v;
        }
    }

// If the JSON object does not yet have a stringify method, give it one.

    if (typeof JSON.stringify !== "function") {
        meta = {    // table of character substitutions
            "\b": "\\b",
            "\t": "\\t",
            "\n": "\\n",
            "\f": "\\f",
            "\r": "\\r",
            "\"": "\\\"",
            "\\": "\\\\"
        };
        JSON.stringify = function (value, replacer, space) {

// The stringify method takes a value and an optional replacer, and an optional
// space parameter, and returns a JSON text. The replacer can be a function
// that can replace values, or an array of strings that will select the keys.
// A default replacer method can be provided. Use of the space parameter can
// produce text that is more easily readable.

            var i;
            gap = "";
            indent = "";

// If the space parameter is a number, make an indent string containing that
// many spaces.

            if (typeof space === "number") {
                for (i = 0; i < space; i += 1) {
                    indent += " ";
                }

// If the space parameter is a string, it will be used as the indent string.

            } else if (typeof space === "string") {
                indent = space;
            }

// If there is a replacer, it must be a function or an array.
// Otherwise, throw an error.

            rep = replacer;
            if (replacer && typeof replacer !== "function" &&
                    (typeof replacer !== "object" ||
                    typeof replacer.length !== "number")) {
                throw new Error("JSON.stringify");
            }

// Make a fake root object containing our value under the key of "".
// Return the result of stringifying the value.

            return str("", {"": value});
        };
    }


// If the JSON object does not yet have a parse method, give it one.

    if (typeof JSON.parse !== "function") {
        JSON.parse = function (text, reviver) {

// The parse method takes a text and an optional reviver function, and returns
// a JavaScript value if the text is a valid JSON text.

            var j;

            function walk(holder, key) {

// The walk method is used to recursively walk the resulting structure so
// that modifications can be made.

                var k;
                var v;
                var value = holder[key];
                if (value && typeof value === "object") {
                    for (k in value) {
                        if (Object.prototype.hasOwnProperty.call(value, k)) {
                            v = walk(value, k);
                            if (v !== undefined) {
                                value[k] = v;
                            } else {
                                delete value[k];
                            }
                        }
                    }
                }
                return reviver.call(holder, key, value);
            }


// Parsing happens in four stages. In the first stage, we replace certain
// Unicode characters with escape sequences. JavaScript handles many characters
// incorrectly, either silently deleting them, or treating them as line endings.

            text = String(text);
            rx_dangerous.lastIndex = 0;
            if (rx_dangerous.test(text)) {
                text = text.replace(rx_dangerous, function (a) {
                    return "\\u" +
                            ("0000" + a.charCodeAt(0).toString(16)).slice(-4);
                });
            }

// In the second stage, we run the text against regular expressions that look
// for non-JSON patterns. We are especially concerned with "()" and "new"
// because they can cause invocation, and "=" because it can cause mutation.
// But just to be safe, we want to reject all unexpected forms.

// We split the second stage into 4 regexp operations in order to work around
// crippling inefficiencies in IE's and Safari's regexp engines. First we
// replace the JSON backslash pairs with "@" (a non-JSON character). Second, we
// replace all simple value tokens with "]" characters. Third, we delete all
// open brackets that follow a colon or comma or that begin the text. Finally,
// we look to see that the remaining characters are only whitespace or "]" or
// "," or ":" or "{" or "}". If that is so, then the text is safe for eval.

            if (
                rx_one.test(
                    text
                        .replace(rx_two, "@")
                        .replace(rx_three, "]")
                        .replace(rx_four, "")
                )
            ) {

// In the third stage we use the eval function to compile the text into a
// JavaScript structure. The "{" operator is subject to a syntactic ambiguity
// in JavaScript: it can begin a block or an object literal. We wrap the text
// in parens to eliminate the ambiguity.

                j = eval("(" + text + ")");

// In the optional fourth stage, we recursively walk the new structure, passing
// each name/value pair to a reviver function for possible transformation.

                return (typeof reviver === "function")
                    ? walk({"": j}, "")
                    : j;
            }

// If the text is not JSON parseable, then a SyntaxError is thrown.

            throw new SyntaxError("JSON.parse");
        };
    }
}());


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//PIPELINE
var superluminalTexturesAssociationWindow = new SuperluminalTexturesWindow(null);
/*
var data = {
	node: {
		name: "car model",
		uid: 12345,
		effectDataStateIndex: "54321",
		effect: {
			compID: 1,
			layerID: 14,
			effectIndex: 5,
		},
	},

	materials:[
		{name:"glass", uid:'111'},
		{name:"rubber", uid:'222'},
		{name:"metal", uid:'333'},
	],
	
	meshes:[
		{name:"wheel", uid:1, enabled: true, materialUID: '222'},
		{name:"hood", uid:2, enabled: true, materialUID: '0'},
		{name:"window", uid:3, enabled: false, materialUID: '111'},
	],
};
superluminalTexturesAssociationWindow.SetData(data);
superluminalTexturesAssociationWindow.OpenWindow();
*/
