﻿// Create an empty dialog window near the upper left of the screen
function SuperluminalAssetDownloadHTTP(messageToServer) {
	this.response = "";
	this.status = "none";
	var host =  "api.superluminal.tv"; 
	var cmd =  "POST /v1/aws/getFile?" + messageToServer + " HTTP/1.1\r\nAuthorization: Bearer tkrzQsSugFyuVs9dUsPx3dXqCq5y8JKE\r\nHost:"+host+"\r\nConnection: close\r\n\r\n";  
	var conn = new Socket;  
	conn.timeout = 10; 
	if (conn.open (host + ':80', 'BINARY')) {
			this.status = "opened";
			conn.write (cmd);  
			this.status = "written";
			while (conn.connected && ! conn.eof) {  
				this.status = "reading";
				this.response += conn.read(1024);
			}
			conn.close(); 
			this.status = "ok";
	} else {
		this.status = "failed";
	}
}

function SuperluminalAssetDownloadWindow() {
	this.width = 450;
	this.height = 200;
	
	this.CheckEnvironment = function() {
		var securitySetting = app.preferences.getPrefAsLong("Main Pref Section", "Pref_SCRIPTING_FILE_NETWORK_SECURITY");
		if (securitySetting != 1) {
			alert ("The download process requires security preference to be set.\n" +
				"Please go to the \"General\" tab on After Effects' preferences panel,\n" +
				"and make sure that \"Allow Scripts to Write Files and Access Network\" is checked.", "Stardust");
			return false;
		}
		return true;
	}

	this.SetupMainWindow = function() {
		this.window = new Window('dialog', 'Download 3D Library');
		this.window.frameLocation = [100,100];
		this.window.size = [this.width,this.height];
		this.window.orientation = 'column';
		this.window.alignChildren = ['fill','top'];
		this.window.onClose = function() {}
		//g = this.window.graphics;
		//var myBrush = g.newBrush(g.BrushType.SOLID_COLOR, [0.1, 0.1, 0.1, 1]); g.backgroundColor = myBrush;
		
		var offset_y = 10;
		var offset_x = 5;
		this.offset_y = offset_y;
		this.offset_x = offset_x;
		this.fieldHeight = 20;
		this.lineGap = 5;
		this.lineHeight = 15;
		this.lastFieldY = 0;

		this.AddStaticText("Please enter your name and serial as it appears on file.");

		this.lastFieldY += 10;

		//data fields:
		this.dataName = this.AddField("Name: ");
		//this.dataOrganization = this.AddField("Organization: ");
		this.dataSerial = this.AddField("Serial: ");

		this.lastFieldY += 5;


		//adding text.
		this.AddStaticText("The 3D model library download is available for free to registered users only.");
		this.AddStaticText("If you encounter probelms with the download process, please contact support.");
		this.AddStaticText("superluminal.tv", [0.2, 0.5, 1, 1], function(){this.windowObj.OpenURLInBrowser("https://www.superluminal.tv");});
		
		//buttons
		var apply = this.window.add('button', undefined, "Send");
		apply.windowObj = this;
		apply.bounds = [this.width - 100 - offset_x, this.height - 30- offset_y, this.width -offset_x, this.height - offset_y];
		apply.onClick = function() { 
			this.windowObj.Send();
			this.windowObj.window.close();
		}
        var prev = apply;		
		
		var cancel = this.window.add('button', undefined, "Cancel");
		cancel.windowObj = this;
         cancel.bounds = prev.bounds;
         cancel.bounds.left -= 105;
         cancel.bounds.right -= 105;
         cancel.onClick = function() {
			this.windowObj.window.close();
		}
		prev = cancel;
	
	}

	this.AddStaticText = function(text, color, onclick) {
		var y = this.lastFieldY + this.offset_y;
		this.lastFieldY = y + this.lineGap;
		var gr = this.window;//.add('group',undefined);
		//g.orientation = "row";
		//g.alignChildren = ['fill','center'];
		
		var t = gr.add('staticText', undefined, text);
		t.bounds = [this.offset_x, y, this.width - this.offset_x, y + this.lineHeight];
		
		if(color) {
			var g = t.graphics;
			var b = g.newPen(g.PenType.SOLID_COLOR, color, 1);
			g.foregroundColor = b;
		}
		
		if(onclick) {
			t.windowObj = this;
			t.addEventListener ('click', onclick, false);
		}
	};

	this.AddField = function(name) {
		var y = this.lastFieldY + this.offset_y;
		this.lastFieldY = y + this.fieldHeight;
		var g= this.window;//.add('group',undefined);
		//g.orientation = "row";
		//g.alignChildren = ['fill','center'];
		var nameText = g.add('staticText', undefined, name);
		nameText.bounds = [this.offset_x, y, this.offset_x + 100, y + this.fieldHeight];
		var field = g.add('editText', undefined, "");
		field.bounds = [this.offset_x + 100, y, this.width - this.offset_x, y + this.fieldHeight];
		return field;
	}

	this.Send = function() {
		var name = this.dataName.text.slice(0, this.dataName.text.length > 3 ? 3 : this.dataName.text.length);
		//var org = this.dataOrganization.text;
		var serial = this.dataSerial.text.slice(0, this.dataSerial.text.length > 17 ? 17 : this.dataSerial.text.length);
		var data = "name=" + encodeURI(name) + "&license=" + encodeURI(serial) + "&os=" + encodeURI(this.GetOS());
		var call = new SuperluminalAssetDownloadHTTP(data);
		if(call.status != "ok") {
			alert("Connection to server failed.");
			return;
		}

		this.ParseResponse(call.response);
	}

	this.ParseResponse = function(r) {
		try {
			var refstr = "HTTP1.1 ";
			var status = parseInt(r.slice(refstr.length, r.length));
			var jsonBit = r.slice(r.indexOf('{'), r.lastIndexOf ('}') + 1);
			var res = eval('(' + jsonBit + ')');
			
			if(status == 200) {
				//handle success.
				alert('Download will automatically start in your web browser.');
				this.OpenURLInBrowser(res.message);
			} else {
				//handle error.
				alert(res.message);
			}
			return;		
		} catch(e) {}
		alert('Unknown error. please contact Superluminal support.');
	}

	this.GetOS = function() {
		if(system.osName != "MacOS") return "WIN";
		return "MAC";
	}
	
	this.OpenURLInBrowser = function(url) {
		switch(this.GetOS()) {
			case "WIN": system.callSystem("explorer " + '"' + url + '"'); break;
			case "MAC": system.callSystem("open " + '"' + url + '"'); break;
		}
	}
	
	this.LaunchWindow = function() {
		this.window.center();
		this.window.show();
	}

	this.LaunchDownloadWindow = function() {
		if(!this.CheckEnvironment()) return;
		this.SetupMainWindow();
		this.LaunchWindow();
	}

	this.LaunchDownloadWindow();
}

function SuperluminalPresetSessionInfo(filter) {
	this.filter = filter;
	this.ops = [];
	
	this.Search = function(str) {
		this.ops.push("search:" + str);
	};
	
	this.Browse = function(str) {
		//this.ops.push("browse:" + str);
	};
	
	this.Select = function(str) {
		//this.ops.push("select:" + str);
	};
	
	this.Apply = function(str) {
		this.ops.push("apply:" + str);
	};

	this.Replace = function(str) {
		this.ops.push("replace:" + str);
	};

	this.Cancel = function() {
		this.ops.push("cancel");
	};
}
var superluminalPresetSessionInfo = new SuperluminalPresetSessionInfo("none");

function SuperluminalPresetFacilities() {
	this.ConvertOsPathToIndexPath = function(path) {
		return "." + path.slice(this.rootFolder.length, path.length).replace(/\\/g, '/');
	};

	this.GetDirectoryList = function(path) {
		var folder = new Folder(path);
		var entries = folder.getFiles();
		var fileNames = [];
		var folderNames = [];
		for(var i = 0; i < entries.length; i++) {
			if(entries[i] instanceof File)		fileNames[fileNames.length] = entries[i].fsName;
			if(entries[i] instanceof Folder)	folderNames[folderNames.length] = entries[i].fsName;
		}
		
		//remove material folders. if a folder is named exactly as one of the prests files (except for the ,jsx ext), then it contains the preset materials and shouldn't be displayed.
		for(var i = 0; i < folderNames.length; i++) {
			for(var j = 0; j < fileNames.length; j++) {
				if(folderNames[i] == fileNames[j].slice(0, fileNames[j].indexOf(".jsx"))) {
					folderNames.splice(i,1);
					i--;
					break;
				}
			}
		}
	
		return {files: fileNames, folders: folderNames};
	};

	this.GetTextFromFile = function(path) {
		try {
			var file = new File(path);
			file.open("r");
			var data = file.read();
			file.close();
			return data;
		} catch(e) { }
		return null;
	};

	this.EvalString = function(str) {
		try {
			var data = eval('(' + str + ')');
			return data;
		} catch(e) { }
		return null;
	};

	this.GetPresetDataFromFile = function(path) {
		return this.EvalString(this.GetTextFromFile(path));
	};

	this.DoesFileFormatQuilfy = function(path) {
		//check extension.
		var ext = path.slice(path.lastIndexOf('.'), path.length);
		if(ext != ".jsx") return false;
		return true;
	};

	this.DoesFileContentQualify = function(text) {
		if(text.indexOf('"presetType":') != -1) return true;
		if(text.indexOf('presetType:') != -1) return true;
		return false;
	};

	this.DoesFileQuilfy = function(path) {
		if(!this.DoesFileFormatQuilfy(path)) return null;
		
		//check it's a preset before evaluating.
		var text = this.GetTextFromFile(path);
		if(!this.DoesFileContentQualify(text)) return null;
		
		//check inner type.
		var data = this.EvalString(text);
		if(data.presetType != this.typeFilter) return null;
	
		//seems we have passed all tests.
		return data;
	};
	
	this.GetCurrentTimeMS = function() {
		return  (new Date().getTime());
	};
}

function SuperluminalPresetIndex(rootFolder, presetCatalogPath) {
	SuperluminalPresetFacilities.call(this);

	this.rootFolder = rootFolder;
	this.catalogFilePath = presetCatalogPath;
	this.searchCatalog = null;
	this.catalogFolderTree = null;
	this.catalogingDone = false;
	this.catalogOperationStartTime = 0;
	this.lastFileIndexed = "none";
	this.presetListChanged = false;
	this.indexingProgressWindowOpen = false;
	this.saveIndexDataToFile = false;
	this.synchronousIndexing = false;
	this.indexingInProgress = false;
	this.indexFileCount = 0;

	this.CreateSeachIndexingProgressWindow = function() {
		if(this.indexingProgressWindow) return;
		var width = 160;
		var height = 50;
		var win = new Window('palette', 'Indexing Presets');
		this.indexingProgressWindow = win;
		win.windowObj= this;
		win.orientation = 'column';
		win.alignChildren = ['fill','top'];
		win.frameLocation = [50,50];
		win.size = [width,height];
		var g = win.graphics;
		win.onClose = function() {
			this.windowObj.indexingProgressWindowOpen = false;
			this.windowObj.indexingProgressWindow = null;
		};
		
		win.counter = 0;
		var inf = win.add('staticText', undefined, "", {multiline:true});
		win.inf = inf;
		inf.graphics.foregroundColor = g.newPen(g.BrushType.SOLID_COLOR, [1, 1, 1, 1], 1);
		inf.text = "Indexing files:";
		inf.windowObj = win;
		inf.bounds =  [5, 5, width - 5, height - 30];
	};

	this.ShowSeachIndexingProgress = function() {
		if(this.indexingProgressWindow) {
			if(!this.indexingProgressWindow.active) this.indexingProgressWindow.active = true;
			return;
		}
		this.CreateSeachIndexingProgressWindow();
		if(superliminalPresetWindowObj) {
			var loc = superliminalPresetWindowObj.window.location;
			this.indexingProgressWindow.location = [loc[0] - this.indexingProgressWindow.size[0], loc[1] + 20];
		} else {
			this.indexingProgressWindow.center();
		}
		this.indexingProgressWindow.show();
		this.indexingProgressWindow.active = true;
		this.indexingProgressWindowOpen = true;
	};

	this.UpdateProgressMessage = function(text) {
		this.indexingProgressWindow.inf.text = text;
		this.indexingProgressWindow.update();
		$.sleep(1);
	};

	this.CatalogFile = function(path) {
		this.lastFileIndexed = path;
		if(!this.DoesFileFormatQuilfy(path)) return null;
		
		//check it's a preset before evaluating.
		var text = this.GetTextFromFile(path);
		if(!this.DoesFileContentQualify(text)) return null;
		
		//catalog preset info.
		var data = this.EvalString(text);
		var e = {};
		
		e.path = this.ConvertOsPathToIndexPath(path);
		e.type = data.presetType;
		
		//name
		var lastSlash = Math.max(path.lastIndexOf('/'), path.lastIndexOf('\\')) + 1;
		e.name = path.slice(lastSlash, path.lastIndexOf('.')).split(/[\s_-]+/);

		//path componenets.
		var minusStartFolder = path.slice(this.rootFolder.length, lastSlash);
		if(minusStartFolder != this.rootFolder) e.folders = minusStartFolder.split(/[\s\\\/]+/);
		else e.folders = [];

		if(data.tags) e.tags = data.tags;
		else e.tags = [];
		
		this.searchCatalog.push(e);
	};


	this.CatalogFolderProcess = function(f) {
		if(!f.entries) f.entries = this.GetDirectoryList(f.path);
		
		//process files.
		for(f.fileIndex; f.fileIndex < f.entries.files.length; f.fileIndex++) {
			this.CatalogFile(f.entries.files[f.fileIndex]);
			//we allow 1/10th of a second for each indexing op.
			//we check after processing the file so at least 1 file will get done on each iteration.
			//that is, only is indexing is not synchronous.
			var t = (new Date().getTime());
			if(!this.synchronousIndexing && t - this.catalogOperationStartTime > 100) {
				this.catalogOperationStartTime = t;
				this.indexFileCount++;
				this.UpdateProgressMessage("Indexing files: " + this.indexFileCount);
			}
		}
	
		//process folders.
		for(f.folderIndex; f.folderIndex < f.entries.folders.length; f.folderIndex++) {
			if(!f.processedFolder) f.processedFolder = new this.CatalogFolder(f.entries.folders[f.folderIndex]);
			this.CatalogFolderProcess(f.processedFolder);
			if(!f.processedFolder.done) return;//not done? quit, and we'll pick it up from here on the next round.
			f.processedFolder = null;
		}
	
		f.done = true;
	};

	this.CatalogFolder = function(path) {
		this.path = path;
		this.processedFolder = null;
		this.folderIndex = 0;
		this.fileIndex = 0;
		this.done = false;
	};
	this.DoCatalogIndexing = function() {
		this.catalogOperationStartTime = new Date().getTime();
		this.CatalogFolderProcess(this.catalogFolderTree);
		if(this.catalogFolderTree.done) {
			this.catalogFolderTree = null;
			this.catalogingDone = true;
			this.saveIndexDataToFile = true;
			this.indexingInProgress = false;
			return true;
		}
		return false;
	};

	this.ResumeSearchCatalogIndexing = function() {
		if(this.catalogingDone || this.DoCatalogIndexing()) {
			if(this.indexingProgressWindowOpen) this.indexingProgressWindow.close();
			return;
		}
		if(this.indexingProgressWindowOpen) {
			this.indexingProgressWindow.inf.text = "indexing preset files:\n" + superluminalPresetIndex.lastFileIndexed;
		}
		//app.scheduleTask("superluminalPresetIndex.ResumeSearchCatalogIndexing()", 10, false);
	};
	
	this.CreateNewSearchCatalog = function() {
		if(this.catalogingDone || this.indexingInProgress) return;
		//create progress window.
		if(!confirm("A search index of all presets is about to be created.\nThis process will take a few seconds.", false, "Stardust")) return;
		if(!this.synchronousIndexing)  {
			this.ShowSeachIndexingProgress ();
		}
	
		if(!this.indexingInProgress) {
			this.indexingInProgress = true;
			this.searchCatalog = [];
			this.catalogFolderTree = new this.CatalogFolder(this.rootFolder);
			this.ResumeSearchCatalogIndexing();
		}
	};

	this.LookupFileInCatalog = function(path) {
		var p = this.ConvertOsPathToIndexPath(path);
		for(var i = 0; i < this.searchCatalog.length; i++) {
			if(this.searchCatalog[i].path == p) return true;
		}
		false;
	};

	this.DoesCatalogFileNeedUpdating = function(path) {
		var t =  this.GetCurrentTimeMS();
		if(t - this.indexCheckStartTime > 1000 &&
			t - this.indexCheckUpdateTime > 100 ) {
			this.indexCheckUpdateTime = t;
			this.ShowSeachIndexingProgress();
			this.UpdateProgressMessage("Checking:\n" + path);
		}
		
		//if it's some random file we can ignore it.
		if(!this.DoesFileFormatQuilfy(path)) return false;
		
		//is it in our catalog already?
		if(this.LookupFileInCatalog(path)) return false;
		
		//check it's a preset before sounding the alarms.
		var text = this.GetTextFromFile(path);
		if(this.DoesFileContentQualify(text)) return true;
		
		//it's some random jsx file. we can ignore it.
		return false;
	};

	this.CheckCatalogFolderNeedUpdating = function(path) {
		var entries = this.GetDirectoryList(path);
		for(var i = 0; i < entries.files.length; i++) if(this.DoesCatalogFileNeedUpdating(entries.files[i])) return true;
		for(var i = 0; i < entries.folders.length; i++) if(this.CheckCatalogFolderNeedUpdating(entries.folders[i])) return true;
		return false;
	};

	this.DoesCatalogFolderNeedUpdating = function(path) {
		var t = this.GetCurrentTimeMS();
		this.indexCheckStartTime = t;
		this.indexCheckUpdateTime = t;
		var r = this.CheckCatalogFolderNeedUpdating(path);
		if(this.indexingProgressWindow) this.indexingProgressWindow.close();
		return r;
	};

	this.IsCatalogFileOutdated = function() {
		if(!this.searchCatalog) return true;
		//var t1 = (new Date().getTime());
		for(var i = 0; i < this.searchCatalog.length; i++) {
			if(this.searchCatalog[i] == "needs updating")  {
				this.searchCatalog.splice(i, 1);
				this.saveIndexDataToFile = true;
				return true;
			}
		}

		//var t2 = (new Date().getTime());
		if(this.DoesCatalogFolderNeedUpdating(this.rootFolder)) return true;
		//var t3 = (new Date().getTime());
		//alert("flag test: " + (t2 - t1) + "\nfile test: " + (t3 - t2));
		return false;
	};

	this.GetSearchCatalogFromFile = function() {
		this.searchCatalog = this.GetPresetDataFromFile(this.catalogFilePath);
		if(this.IsCatalogFileOutdated()) return false;
		this.catalogingDone = true;
		return true;
	};

	this.ShouldCreateNewCatalog = function() {
		if(this.catalogingDone) return false;
		if(!this.indexingInProgress && this.GetSearchCatalogFromFile()) return false;
		return true;
	};

	this.ForceNewSearchCatalog = function() {
		this.catalogingDone = false;
		this.CreateNewSearchCatalog();
	};

	this.CreateSearchCatalog = function() {
		if(!this.ShouldCreateNewCatalog()) return false;
		this.CreateNewSearchCatalog();
		return true;
	};
	
	this.MatchSearchString = function(term, catalog, matchScore, partScore) {
		//making our serach ignore case.
		term = term.toLowerCase();
		catalog = catalog.toLowerCase();
		if(term == catalog) return matchScore;//perfect match.
		if(term.length > catalog.length) return 0;//search term is longer than the catalog string. can't be a match.
		if(catalog.indexOf(term) !== -1) return partScore; //catalog string contains the search term.
		return 0;//no match.
	};

	this.MatchSrearchArray = function(term, catalogArray, matchScore, partScore) {
		var score = 0;
		for(var i = 0; i < catalogArray.length; i++) {
			score += this.MatchSearchString(term, catalogArray[i], matchScore, partScore);
		}
		return score;
	};

	this.QueryEntryForSingleWord = function(word, e) {
		if(!word || !word.length || word == "") return 0;
		var score = 0;
		
		//searching different criterea, giving a different score for full and partial match to affect sorting importance.
		score += this.MatchSrearchArray(word, e.name, 10, 5);
		score += this.MatchSrearchArray(word, e.folders, 5, 2);		
		score += this.MatchSrearchArray(word, e.tags, 20, 2);	
		
		return score;
	};

	this.QueryEntry = function(entry, words) {
		entry.searchScore = 0;
		if(entry.type != this.typeFilter) return;
		for(var i = 0; i < words.length; i++) {
			entry.searchScore += this.QueryEntryForSingleWord(words[i], entry);
		}
	};

	this.PathRelativeToAbsolute = function(path) {
		//we currently deal only with forward paths.
		return this.rootFolder + path.slice(1, path.length);
	};

	this.SearchResultsSort = function(a, b) {//descending order.
		if(a.searchScore < b.searchScore) return 1;
		if(a.searchScore > b.searchScore) return -1;
		return 0;
	}

	this.SearchQuery = function(text, typeFilter) {
		this.typeFilter = typeFilter;
		
		//score entries by compatibility to serach term.
		var results = [];
		var words = text.split(' ');
		for(var i = 0; i < this.searchCatalog.length; i++) {
			var entry = this.searchCatalog[i];
			this.QueryEntry(entry, words);
			if(entry.searchScore) results.push(entry);
		}
	
		//sort results by match score.
		results.sort(this.SearchResultsSort);
		
		//convert catalog list to file paths list.
		var entriesPaths = {folders:[], files:[]};
		for(var i = 0; i < results.length; i++) entriesPaths.files.push(this.PathRelativeToAbsolute(results[i].path));
		return entriesPaths;
	};
}

function SuperluminalPresetWindow(windowResourceFolder, startFolder, typeFilter, add, replace) {
	SuperluminalPresetFacilities.call(this);

	this.windowResourceFolder = windowResourceFolder;
	this.startFolder = startFolder;
	this.typeFilter = typeFilter;
	this.width = 1080;
	this.height = 750;
	this.selectedEntry = 0;
	this.result =  '({operation:"cancel", path:"null"})';
	this.numEntries = 0;
	this.container;
	this.presetEntries = [];
	this.entryWidth = 200;
	this.entryHeight = 160;
	this.xGap = 10;
	this.yGap = 10;
	this.oldScrollableGroup = null;
    this.addButton = add;
    this.replaceButton = replace;
	this.showOptions = (add || replace);
	
	this.PathToName = function(path) {
		var lastSlash = Math.max(path.lastIndexOf('/'), path.lastIndexOf('\\')) + 1;
		return path.slice(lastSlash, path.lastIndexOf('.'));
	};
	
	this.SetupMainWindow = function() {
		this.window = new Window('dialog', 'Stardust Presets');
		this.window.frameLocation = [100,100];
		this.window.size = [this.width,this.height];
		this.window.orientation = 'column';
		this.window.alignChildren = ['fill','top'];
		this.window.onClose = function() {}
		g = this.window.graphics;
		myBrush = g.newBrush(g.BrushType.SOLID_COLOR, [0.1, 0.1, 0.1, 1]); g.backgroundColor = myBrush;
		
		var apply = this.window.add('button', undefined, this.addButton ? "Add" : "Apply");

		var offset_y = 10;
		var offset_x = 5;

		apply.windowObj = this;
		apply.bounds = [this.width - 100 - offset_x, this.height - 30- offset_y, this.width -offset_x, this.height - offset_y];
		apply.onClick = function() { 
			superluminalPresetSessionInfo.Apply(this.windowObj.PathToName(this.windowObj.presetEntries[this.windowObj.selectedEntry].presetPath));
             var res = '({operation:"ok", path:"' + this.windowObj.presetEntries[this.windowObj.selectedEntry].presetPath + '", options:' + this.windowObj.ExportOptions() + '})';
			this.windowObj.result = res;
			this.windowObj.window.close();
		}
        var prev = apply;
        
		//search box
		this.search_text = this.window.add('editText', undefined, "", {enterKeySignalsOnChange:true});
		this.search_text.bounds =  [15 + 30, 5, 420 + 00, 26 + 2];
		this.search_text.windowObj = this;
		this.search_text.onChanging = function() {
			if(!this.text.length) this.windowObj.DoSearch();
		}
//		this.search_text.onChange = function() { this.windowObj.DoSearch(); }
		this.search_text.onEnterKey = function() { this.windowObj.DoSearch(); }

		this.search_button = this.window.add('button', undefined, "Search");
		this.search_button.bounds =  [15, 5, 40 , 26 + 2];

		//this.search_button.bounds =  [460 - 30, 5, 510 - 25 - 30, 26 + 2];
		this.search_button.windowObj = this;
		this.search_button.onClick = function() { this.windowObj.DoSearch(); }

		this.search_icon_image = ScriptUI.newImage(this.windowResourceFolder + "/search_icon.png");
        var search_icon_image_ref = this.search_icon_image ;
        var search_icon_ref = this.search_button;
        search_icon_ref.onDraw = function(drawingState) {

            search_icon_ref.graphics.drawImage (search_icon_image_ref, 0 + 00 , 0, 22, 22);

        }
	
	
//		this.search_index_refresh = this.window.add('button', undefined, "Index");
//		this.search_index_refresh.bounds =  [420 + 5, 5, 420 + 5 + 35 , 26 + 2];
//		this.search_index_refresh.windowObj = this;
//		this.search_index_refresh.onClick = function() { this.windowObj.ForceIndexing(); }



		//download assets button.
        if(1) {
			this.download = this.window.add('button', undefined, "Download 3D Library");
			this.download.bounds =  [this.width - 100 - offset_x - 30, offset_y, this.width -offset_x - 10, 20 + offset_y];
			this.download.windowObj = this;
			this.download.onClick = function() { 
				this.windowObj.window.close();
				var downloadWindow = new SuperluminalAssetDownloadWindow();
			}
       }


		this.folder_text = this.window.add('staticText', undefined, "");
		this.folder_text.bounds =  [60, this.height - 28 - offset_y, 850 - 250, this.height - offset_y];


        var replace_button;
        if(this.replaceButton) {
            var replace_button = this.window.add('button', undefined, "Replace");

            replace_button.windowObj = this;
            replace_button.bounds = prev.bounds;
            replace_button.bounds.left -= 105;
            replace_button.bounds.right -= 105;
            replace_button.onClick = function() { 
				superluminalPresetSessionInfo.Replace(this.windowObj.PathToName(this.windowObj.presetEntries[this.windowObj.selectedEntry].presetPath));
                var res = '({operation:"replace", path:"' + this.windowObj.presetEntries[this.windowObj.selectedEntry].presetPath + '", options:' + this.windowObj.ExportOptions() + '})';
                this.windowObj.result = res;
                this.windowObj.window.close();
            }
            prev = replace_button;
        }
		
		
		
		var cancel = this.window.add('button', undefined, "Cancel");
		cancel.windowObj = this;
         cancel.bounds = prev.bounds;
         cancel.bounds.left -= 105;
         cancel.bounds.right -= 105;
         cancel.onClick = function() {
				superluminalPresetSessionInfo.Cancel();
			this.windowObj.window.close();
		}
		prev = cancel;
	
		if(this.showOptions) {
			this.option01 = this.window.add('checkbox', undefined, "Apply Render Settings");
			this.option01.value = true;
	//		this.option01.bounds = prev.bounds;
	//		this.option01.bounds.left = prev.bounds.left;
	//		this.option01.bounds.top = prev.bounds.top - 20;
	//		this.option01.bounds.width = 200;
	//		this.option01.bounds.height = 20;

			this.option01.bounds =  [610, this.height - 28 + 7 - offset_y, 860, this.height + 7 - offset_y];

		}

		this.folderImage = ScriptUI.newImage(this.windowResourceFolder + "/folder.png");
		this.folderImageUp = ScriptUI.newImage(this.windowResourceFolder + "/folder_up.png");
		this.folderImageA = ScriptUI.newImage(this.windowResourceFolder + "/folder_a.png");

		folder_button = this.window.add('button', undefined, "");
		folder_button.windowObj = this;
		folder_button.bounds = [0, this.height - 30- offset_y, 60, this.height- offset_y];
		
		//this.folder_button = folder_button;
		var image1 = this.folderImageA ;
		folder_button.onDraw = function(drawingState) {
		
			folder_button.graphics.drawImage (image1, 5, 0, 60, 30);

		}


		
		folder_button.onClick = function(){
			var folderSelect = Folder.selectDialog("Please choose a folder");
			if(folderSelect)
			{
						this.windowObj.CreatePresetListForPath(folderSelect.fullName);
			} 
		}
	}
	
	this.ExportOptions = function() {
		if(!this.showOptions) return "{}";
		return "{ importGlobals: " + (this.option01.value ? "1" : "0") + " }";
	};
	this.HandleSearchTextChange = function() {
		this.galleryContentBy = "search";
		var entriesPaths = superluminalPresetIndex.SearchQuery(this.search_text.text, this.typeFilter);
		this.oldScrollableGroup = this.container;
		this.CreateNewPresetList();
		this.PopulateGallery(this.startFolder, entriesPaths);
		superluminalPresetSessionInfo.Search(this.search_text.text);
	};

	this.CheckDoSearch = function() {
		//is our search all spaces?
		var allSpaces = true;
		for(var i = 0; i < this.search_text.text.length; i++) {
			if(this.search_text.text[i] != " ") {
				allSpaces = false;
				break;
			}
		}

		if(this.galleryContentBy == "browse") {
			//in case the current content is "browse" we null the last search string,
			//so we won't try to match it and rule out a search.
			this.lastSearchString = null;
		} else {
			//only if we're currently in search, and only if the new text is blank (or all spaces), we trigger a root browse.
			if(allSpaces || !this.search_text.text.length) {
				this.CreatePresetListForPath(this.startFolder);
				this.searchInProgress = false;
				return false;
			}
		}
		if(allSpaces) return false;
		if(this.lastSearchString == this.search_text.text) return false;
		this.lastSearchString = this.search_text.text;
		return true;
	};

	this.DoSearch = function() {
		if(this.searchInProgress) {
			this.pendingSearchRedo = true;
			return;
		}
	
		this.CheckIndexing();
	
		this.searchInProgress = true;
		if(!this.CheckDoSearch()) {
			this.searchInProgress = false;
			return;
		}
		this.presetListChanged = true;
		this.HandleSearchTextChange();

		this.searchInProgress = false;
		if(this.pendingSearchRedo) {
			this.pendingSearchRedo = false;
			this.DoSearch();
		}
	};

	this.DoIndexing = function() {
		//this.window.close();
		superluminalPresetIndex.CreateSearchCatalog();
	};

	this.ForceIndexing = function() {
		//this.window.close();
		superluminalPresetIndex.ForceNewSearchCatalog();
	};

	this.CheckIndexing = function() {
		if(superluminalPresetIndex.ShouldCreateNewCatalog()) {
			this.DoIndexing();
			return true;
		}
		return false;
	};

	this.LaunchWindow = function() {
		this.window.center();
		this.window.show();
	}

	this.CreateScrollableGroup = function(container, size) {
		//delete old.
		if(this.oldScrollableGroup) {
			container.remove(this.oldScrollableGroup.group);
			this.oldScrollableGroup = null;
		}
		
		var barWidth = 20;
		
		var p1= container.add('panel',undefined);
		p1.orientation = "row";
		p1.bounds = [0,0,size[0],size[1]];
		
		var p2= p1.add('group',undefined);
		p2.orientation = "stack";
		p2.bounds = [0,0,size[0] - barWidth,size[1] ];

		var s = p1.add('scrollbar',undefined); 
		s.bounds = [p1.bounds.width - barWidth, 0, p1.bounds.width, p1.bounds.height ];
		s.onChanging = function () {
			var delta = p1.size[1] - p2.size[1];
			p2.location.y = delta * (s.value / 100) ;
			//p2.location.y = s.value*(p1.bounds[3]-p1.bounds[1])/100 - s.value*(p2.bounds[3]-p2.bounds[1])/100;
			//p2.location.y = 100;
		}; 
	
		var ScrollGroup = {group: p1, innerContainer: p2, scrollbar: s, contentHeight: 0};
		
		return ScrollGroup;
	}

	this.FillPresetEntry = function(path, data, container) {
		container.windowObj = this;
		
		container.presetPath = path;
		this.folder_text.text =container.presetPath; 
		//container.text = presetData.name;
		var lastSlash = Math.max(path.lastIndexOf('/'), path.lastIndexOf('\\')) + 1;
		var thePresetName = path.slice(lastSlash, path.lastIndexOf('.'));
		container.text = "";
		
		var inner = container.add('group', undefined);
		inner.bounds = [0, 0, container.bounds.width, container.bounds.height];
		
		var imageWidth = container.size[0] - 10;
		var imageHeight = imageWidth / 16 * 9;
		var picturePath = path.slice(0, path.lastIndexOf('.')) + ".png";
		var image = ScriptUI.newImage(picturePath);
		inner.onDraw = function(drawingState) {
		
			inner.graphics.drawImage (image, 5, 5, imageWidth, imageHeight);

		}

		
			
			var  etxt_s = container.add('staticText', undefined, thePresetName);
			etxt_s.bounds = [0, imageHeight +10 ,imageWidth, imageHeight+40];
			etxt_s.alignment = ['center' , 'center'];
			etxt_s.justify = 'center';
		//cheating AE into listening to events.
		var button = inner.add('button', undefined, undefined);
		button.bounds = [0, 0, container.bounds.width, container.bounds.height];
		button.bounds = [0, 0, imageWidth, imageHeight];

		
		button.onDraw = function(drawingState) {
							button.graphics.drawImage (image, 5, 5, imageWidth, imageHeight);			
			};

		button.onClick = function clickity(e) {
			container.windowObj.selectedEntry = container.entryIndex;
			container.windowObj.PlaceSelectionFrame();
			
			superluminalPresetSessionInfo.Select(thePresetName);
		}


		container.addEventListener('click', clickity);

		function clickity(e) {
			container.windowObj.selectedEntry = container.entryIndex;
			container.windowObj.PlaceSelectionFrame();		
			
			superluminalPresetSessionInfo.Select(thePresetName);
		}
		
		

		
	
	}

	this.FillFolderEntry = function(folder, container, folder_kind) {
		container.windowObj = this;
		
		var lastSlash = Math.max(folder.lastIndexOf('/'), folder.lastIndexOf('\\')) + 1;
		container.text = "" ;//folder.slice(lastSlash, folder.length);

		var thePresetName ='';		
			if(folder_kind == 1)
		thePresetName ='Up to: ';
		thePresetName += folder.slice(lastSlash, folder.length);
		var inner = container.add('group', undefined);
		inner.bounds = [0, 0, container.bounds.width, container.bounds.height];
		
		var imageWidth = container.size[0] - 10;
		var imageHeight = imageWidth / 16 * 9;
		var folderImage = this.folderImage;

		if(folder_kind == 2)
			return;

	if(folder_kind == 1)
		folderImage = this.folderImageUp;
		
		inner.onDraw = function(drawingState) {
		}
	
	
		var  etxt_s = container.add('staticText', undefined, thePresetName);
			etxt_s.bounds = [0, imageHeight +10 ,imageWidth, imageHeight+40];			
			etxt_s.justify = 'center';

	
		//cheating AE into listening to events.
		var button = container.add('button', undefined, undefined);
		button.bounds = [0, 0, container.bounds.width, container.bounds.height];
		button.bounds = [0, 0, imageWidth, imageHeight];
		
			button.onDraw = function(drawingState) { 
				button.graphics.drawImage (folderImage, 5, 5, imageWidth, imageHeight);			
			}
		button.onClick =  function clickity(e) {
			var oldEntryList = container.windowObj.container;
			oldEntryList.group.hide();
			container.windowObj.CreatePresetListForPath(folder);
			container.windowObj.oldScrollableGroup = oldEntryList;//setting this last, so it gets deleted next time aorund, when it's not in mid call.
		}

//		container.addEventListener('click', clickity);
//		function clickity(e) {
//		}

	}

	this.CreateSelectionFrame = function(container) {
		this.selectionFrame = container;
		container.onDraw = function(drawingState) {
			container.graphics.newPath();
			container.graphics.rectPath(0, 0, container.bounds.width, container.bounds.height);
			container.graphics.closePath();
			
			var pen = container.graphics.newPen(container.graphics.PenType.SOLID_COLOR, [.6, .6, .6, 1], 5);
			container.graphics.strokePath(pen);
		}
	}

	this.PlaceSelectionFrame = function() {
		var temp = this.presetEntries[this.selectedEntry].location;
		this.selectionFrame.location.x = temp.x - 5;
		this.selectionFrame.location.y = temp.y - 5;
	}

	this.ClearPresetList = function() {
/*		for(var i = 0; i < this.numEntries; i++) {
			this.container.innerContainer.remove(i);
		}*/
		this.presetEntries = [];
		this.numEntries = 0;
		this.presetListChanged = false;
	}

	this.GetCoordinates = function(index) {
		var maxWidth = this.container.innerContainer.bounds.width;
		var maxEntriesPerLine = Math.floor((maxWidth + this.xGap) / (this.entryWidth + this.xGap));

		var x = (index % maxEntriesPerLine) * (this.entryWidth + this.xGap);
		var y = Math.floor((index / maxEntriesPerLine)) * (this.entryHeight +this.yGap);
		return [x,y];
	}

	this.CreateEntry = function(i) {
			var xy = this.GetCoordinates(i);
			var x = xy[0] + 5;
			var y = xy[1] + 5;
			
					
			
			var entryContainer = this.container.innerContainer.add("panel", undefined);
			entryContainer.orientation = 'stack';
			entryContainer.bounds = [x, y, x + this.entryWidth, y + this.entryHeight];
			entryContainer.entryIndex = i;
		
			this.presetEntries[i] = entryContainer;
			
			this.lastY = y;
			
			g = entryContainer.graphics;
			myBrush = g.newBrush(g.BrushType.SOLID_COLOR, [0.09, 0.09, 0.09, 1]); 
			g.backgroundColor = myBrush;		
				
	
			return entryContainer;
	}

	this.PopulateGallery = function(path, entriesPaths) {		
		//add folders first.
		for(var i = 0; i < entriesPaths.folders.length; i++) {
			if(this.presetListChanged) return;
			var entryContainer = this.CreateEntry(this.numEntries);
			this.FillFolderEntry(entriesPaths.folders[i], entryContainer,0); // normal folder
			this.numEntries++;
		}
	
		//the the files.
		this.selectedEntry = this.numEntries;
		for(var i = 0; i < entriesPaths.files.length; i++) {
			if(this.presetListChanged) return;
			var data = this.DoesFileQuilfy(entriesPaths.files[i]);
			if(data) {
				var entryContainer = this.CreateEntry(this.numEntries);
				this.FillPresetEntry(entriesPaths.files[i], data, entryContainer);
				this.numEntries++;
			}
		}
	
		// [TODO] this is a quick fix for navigation bug
		{
			var lastSlash = Math.max(path.lastIndexOf('/'), path.lastIndexOf('\\'));
		
			var targetPath = path.slice(0, lastSlash);
			var entryContainer = this.CreateEntry(this.numEntries);
			this.FillFolderEntry(targetPath, entryContainer,2); // an empty folder .. fixing a bug for now....
			entryContainer.text = "";
			this.numEntries++;
		}	
	
	
		if(this.selectedEntry == this.numEntries) this.selectedEntry = this.numEntries -1;//no change? probably no entires.
		
		var finalHeight = this.lastY + this.entryHeight +this.yGap;
		this.container.innerContainer.bounds.height = finalHeight ;
		if(finalHeight <= this.container.group.bounds.height) this.container.scrollbar.hide();

		
		var frame = this.container.innerContainer.add("group", undefined);
		frame.bounds = [0, 0, this.entryWidth + 10, this.entryHeight + 10];
		this.CreateSelectionFrame(frame);
		this.PlaceSelectionFrame();
		this.numEntries++;

	};


	this.CreateNewPresetList = function() {
		this.container = this.CreateScrollableGroup(this.window, [this.width - 10, this.height - (this.showOptions ? 70 : 70)]);
		this.container.group.location = [5, 25 + 5];
		this.ClearPresetList();
		this.lastY = 0;
	};

	this.CreatePresetListForPath = function(path) {
		this.galleryContentBy = "browse";
		this.CreateNewPresetList();
		var entriesPaths = this.GetDirectoryList(path);

		//add an "up folder" button.
		{
			var lastSlash = Math.max(path.lastIndexOf('/'), path.lastIndexOf('\\'));
		
			var targetPath = path.slice(0, lastSlash);
			var entryContainer = this.CreateEntry(this.numEntries);
			this.FillFolderEntry(targetPath, entryContainer,1); // an up folder
			entryContainer.text = "";
			this.numEntries++;

			superluminalPresetSessionInfo.Browse(path.slice(lastSlash + 1, path.length));
		}
	
		this.PopulateGallery(path, entriesPaths);
	}

	this.LaunchPresetWindow = function() {
		superluminalPresetSessionInfo = new SuperluminalPresetSessionInfo(this.typeFilter);
		this.SetupMainWindow();
		this.CreatePresetListForPath(this.startFolder);
		this.LaunchWindow();
	}
}

var superluminalPresetIndex;
function SuperluminalCreatePresetsIndex(presetsFolderPath, presetCatalogPath) {
	superluminalPresetIndex = new SuperluminalPresetIndex(presetsFolderPath, presetCatalogPath);
}

function SuperluminalGetSavePresetCatalog() {
	if(!superluminalPresetIndex.saveIndexDataToFile) return "false";
	superluminalPresetIndex.saveIndexDataToFile = false;
	return JSON.stringify(superluminalPresetIndex.searchCatalog);
}

var superliminalPresetWindowObj;
function SuperluminalLaunchPresetWindow(resource, path, filter, add, replace) {
	//if(superluminalPresetIndex.CreateSearchCatalog()) return;
	var windowObj = new SuperluminalPresetWindow(resource, path, filter, add, replace);
	superliminalPresetWindowObj = windowObj;
	windowObj.LaunchPresetWindow();
	superliminalPresetWindowObj = null;
	return windowObj.result;
}

//var scriptsFile = new File($.fileName);//self path.
//var scriptFileFolder = scriptsFile.path;//parent folder path.
//SuperluminalCreatePresetsIndex("X:/Stardust_workspace/bitwise/_Built_plug-ins_64/Stardust/Presets", "C:/ProgramData/Superluminal/Stardust/preset_catalog.txt");
//superluminalPresetIndex.CreateSearchCatalog();
//var temp = SuperluminalLaunchPresetWindow(scriptFileFolder, "X:/Stardust_workspace/bitwise/_Built_plug-ins_64/Stardust/Presets/All presets/General", "general");
